//************************************************************
//  University of Patras
//	Department of Electrical Engineering & Computer Technology
//
//	Course: Parallel Programming in AI
//	Week 04: OpenMp
//
//  Description: Simple examples  in openMP
//  	omp03.c: the hello work openmp version
//	Author: Evangelos Dermatas
//	v0.1
/*
*********************************************************************
gcc -v:	gcc version 7.4.0 (Ubuntu 7.4.0-1ubuntu1~18.04.1)
OS: 	Linux Ubuntu 18.04
CPU:	8-core, Intel(R) Core(TM) i7-2630QM CPU @ 2.00GHz, 3991 BogoMips
*********************************************************************
Compiling:	gcc omp03.c -o omp03 -fopenmp
Executing:	./omp03
Output in my Laptop:

Hello openMP section 3
Hello openMP section 1
Hello openMP section 2

*/
//************************************************************

#include <stdio.h>
#include <stdlib.h>
#include <omp.h>

// **************************************************************
int main(void) 
{

omp_set_num_threads(8);

#pragma omp parallel sections
{

// *********************** Section 1 ****************
#pragma omp section
{
	printf( "Hello openMP section 1\n" ) ;
}

// *********************** Section 1 ****************
#pragma omp section
{
	printf( "Hello openMP section 2\n" ) ;
}

#pragma omp flush
#pragma omp flush(i,j)
// #pragma omp barrier

// *********************** Section 1 ****************
#pragma omp section
{
	printf( "Hello openMP section 3\n" ) ;
}

}


#pragma omp parallel sections
{

// *********************** Section 1 ****************
#pragma omp section
{
	printf( "Hello openMP section 4\n" ) ;
}

// *********************** Section 1 ****************
#pragma omp section
{
	printf( "Hello openMP section 5\n" ) ;
}
}



	return 0 ;
}
